import ibhua

#Monitor
def Monitor_var_Intl6_always(var):
    myVar=var//2
    ibhua.OPCWriteVar("ns=4;s=IBH Link UA.PLC416.Programs.DataIn-Nodeset.ValueIn",myVar)
    return

#InVar : Float
InVar_ns1_6000 = 0.0
def Read_InVar_ns1_6000():
    x=2
    InVar_ns1_6000=x*ibhua.OPCReadVar("ns=4;s=IBH Link UA.PLC416.Programs.DataIn-Nodeset.RealData")
    return InVar_ns1_6000

def Write_InVar_ns1_6000(value):
    global InVar_ns1_6000
    InVar_ns1_6000 = value
    return

#CounterVar : Int16
CounterVar_ns1_6001 = 0
def Read_CounterVar_ns1_6001():
    CounterVar_ns1_6001=ibhua.OPCReadVar("ns=4;s=IBH Link UA.PLC416.Programs.CounterValues.Structure.MaxValue")
    return CounterVar_ns1_6001

def Write_CounterVar_ns1_6001(value):
    global CounterVar_ns1_6001
    CounterVar_ns1_6001 = value
    return

#OutVar : Float
OutVar_ns1_6002 = 0.0
def Read_OutVar_ns1_6002():
    return OutVar_ns1_6002

def Write_OutVar_ns1_6002(value):
    global OutVar_ns1_6002
    ibhua.OPCWriteVar("ns=4;s=IBH Link UA.PLC416.Programs.DataIn-Nodeset.RealData",value)
    return

#OutRes : Int16
OutRes_ns1_6003 = 0
def Read_OutRes_ns1_6003():
    x=20
    y=25
    z=500
    OutRes_ns1_6003=x+y+z
    return OutRes_ns1_6003

def Write_OutRes_ns1_6003(value):
    global OutRes_ns1_6003
    OutRes_ns1_6003 = value
    return

#In    Value1 : Float, Value2 : Float
#Out   Result : Float
def UserMethod_ns1_7004(Value1, Value2):
    Result=Value1+Value2
    return Result

def init_opc():
    ns1 = ibhua.get_namespace("http://example.com")
    ibhua.variable(ns1,6000,"Read_InVar_ns1_6000","Write_InVar_ns1_6000")               #Float
    ibhua.variable(ns1,6001,"Read_CounterVar_ns1_6001","Write_CounterVar_ns1_6001")     #Int16
    ibhua.variable(ns1,6002,"Read_OutVar_ns1_6002","Write_OutVar_ns1_6002")             #Float
    ibhua.variable(ns1,6003,"Read_OutRes_ns1_6003","Write_OutRes_ns1_6003")             #Int16
    ibhua.method(ns1,7004,"UserMethod_ns1_7004")
    ibhua.monitor("ns=4;s=IBH Link UA.PLC416.Programs.CounterValues.ValueCounter","Monitor_var_Intl6_always",1000,0,0)
    return
